import { ElementRef } from '@angular/core';
import { DomPortal } from '@angular/cdk/portal';
import { BehaviorSubject } from 'rxjs';
import { BsDockPane } from '../panes/dock-pane';
import { EPaneType } from '../enums/pane-type.enum';
import { BsSplitPane } from '../panes/split-pane';
import { BsContentPane } from '../panes/content-pane';
import { BsDocumentHost } from '../panes/document-host-pane';
import { BsTabGroupPane } from '../panes/tab-group-pane';
import { BsFloatingPane } from '../panes/floating-pane';
import { Overlay } from '@angular/cdk/overlay';
import * as i0 from "@angular/core";
export declare class BsDockPaneRendererComponent {
    private overlay;
    constructor(overlay: Overlay, element: ElementRef);
    portal: DomPortal;
    paneTypes: typeof EPaneType;
    readonly BsDocumentHostType: typeof BsDocumentHost;
    readonly BsTabGroupType: typeof BsTabGroupPane;
    readonly BsSplitterType: typeof BsSplitPane;
    readonly BsContentPaneType: typeof BsContentPane;
    readonly BsFloatingPaneType: typeof BsFloatingPane;
    layout$: BehaviorSubject<BsDockPane | null>;
    get layout(): BsDockPane | null;
    set layout(value: BsDockPane | null);
    private overlayRef?;
    moveToOverlay(): void;
    disposeOverlay(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<BsDockPaneRendererComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<BsDockPaneRendererComponent, "bs-dock-pane-renderer", never, { "layout": { "alias": "layout"; "required": false; }; }, {}, never, never, false, never>;
}
