import * as i0 from '@angular/core';
import { Component, Input, ViewChild, forwardRef, Directive, HostListener, Optional, Host, NgModule } from '@angular/core';
import * as i1 from '@angular/common';
import { CommonModule } from '@angular/common';
import { BehaviorSubject, map } from 'rxjs';
import { NG_VALUE_ACCESSOR } from '@angular/forms';

class BsSelectComponent {
    constructor(renderer) {
        this.renderer = renderer;
        // For debugging purposes
        this.identifier = 0;
        //#region Size
        this.size$ = new BehaviorSubject('md');
        //#endregion
        //#region Multiple
        this.multiple$ = new BehaviorSubject(false);
        //#endregion
        //#region NumberVisible
        this.numberVisible$ = new BehaviorSubject(null);
        this.sizeClass$ = this.size$.pipe(map((size) => {
            switch (size) {
                case 'sm':
                case 'lg':
                    return `form-select-${size}`;
                default:
                    return null;
            }
        }));
        this.multipleValue$ = this.multiple$.pipe(map((multiple) => {
            if (multiple) {
                return true;
            }
            else {
                return null;
            }
        }));
    }
    ngOnInit() { }
    get size() {
        return this.size$.value;
    }
    set size(value) {
        this.size$.next(value);
    }
    get multiple() {
        return this.multiple$.value;
    }
    set multiple(value) {
        this.multiple$.next(value);
    }
    get numberVisible() {
        return this.numberVisible$.value;
    }
    set numberVisible(value) {
        this.numberVisible$.next(value);
    }
    //#endregion
    //#region Disabled
    get disabled() {
        return this.selectBox.nativeElement.disabled;
    }
    set disabled(value) {
        if (this.selectBox) {
            this.renderer.setProperty(this.selectBox.nativeElement, 'disabled', value);
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.0.4", ngImport: i0, type: BsSelectComponent, deps: [{ token: i0.Renderer2 }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.0.4", type: BsSelectComponent, selector: "bs-select", inputs: { identifier: "identifier", size: "size", multiple: "multiple", numberVisible: "numberVisible", disabled: "disabled" }, viewQueries: [{ propertyName: "selectBox", first: true, predicate: ["selectBox"], descendants: true }], ngImport: i0, template: "<select class=\"form-select\" #selectBox [class]=\"sizeClass$ | async\" [attr.multiple]=\"multipleValue$ | async\" [attr.size]=\"numberVisible$ | async\" aria-label=\"Default select example\">\n    <ng-content></ng-content>\n</select>", styles: [":host ::ng-deep .form-select{--bs-form-select-bg-img: url(\"data:image/svg+xml,%3csvg xmlns='http://www.w3.org/2000/svg' viewBox='0 0 16 16'%3e%3cpath fill='none' stroke='%23343a40' stroke-linecap='round' stroke-linejoin='round' stroke-width='2' d='m2 5 6 6 6-6'/%3e%3c/svg%3e\");display:block;width:100%;padding:.375rem 2.25rem .375rem .75rem;font-size:1rem;font-weight:400;line-height:1.5;color:var(--bs-body-color);background-color:var(--bs-body-bg);background-image:var(--bs-form-select-bg-img),var(--bs-form-select-bg-icon, none);background-repeat:no-repeat;background-position:right .75rem center;background-size:16px 12px;border:var(--bs-border-width) solid var(--bs-border-color);border-radius:var(--bs-border-radius);transition:border-color .15s ease-in-out,box-shadow .15s ease-in-out;-webkit-appearance:none;appearance:none}@media (prefers-reduced-motion: reduce){:host ::ng-deep .form-select{transition:none}}:host ::ng-deep .form-select:focus{border-color:#86b7fe;outline:0;box-shadow:0 0 0 .25rem #0d6efd40}:host ::ng-deep .form-select[multiple],:host ::ng-deep .form-select[size]:not([size=\"1\"]){padding-right:.75rem;background-image:none}:host ::ng-deep .form-select:disabled{background-color:var(--bs-secondary-bg)}:host ::ng-deep .form-select:-moz-focusring{color:transparent;text-shadow:0 0 0 var(--bs-body-color)}:host ::ng-deep .form-select-sm{padding-top:.25rem;padding-bottom:.25rem;padding-left:.5rem;font-size:.875rem;border-radius:var(--bs-border-radius-sm)}:host ::ng-deep .form-select-lg{padding-top:.5rem;padding-bottom:.5rem;padding-left:1rem;font-size:1.25rem;border-radius:var(--bs-border-radius-lg)}:host ::ng-deep [data-bs-theme=dark] .form-select{--bs-form-select-bg-img: url(\"data:image/svg+xml,%3csvg xmlns='http://www.w3.org/2000/svg' viewBox='0 0 16 16'%3e%3cpath fill='none' stroke='%23adb5bd' stroke-linecap='round' stroke-linejoin='round' stroke-width='2' d='m2 5 6 6 6-6'/%3e%3c/svg%3e\")}\n"], dependencies: [{ kind: "pipe", type: i1.AsyncPipe, name: "async" }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.0.4", ngImport: i0, type: BsSelectComponent, decorators: [{
            type: Component,
            args: [{ selector: 'bs-select', template: "<select class=\"form-select\" #selectBox [class]=\"sizeClass$ | async\" [attr.multiple]=\"multipleValue$ | async\" [attr.size]=\"numberVisible$ | async\" aria-label=\"Default select example\">\n    <ng-content></ng-content>\n</select>", styles: [":host ::ng-deep .form-select{--bs-form-select-bg-img: url(\"data:image/svg+xml,%3csvg xmlns='http://www.w3.org/2000/svg' viewBox='0 0 16 16'%3e%3cpath fill='none' stroke='%23343a40' stroke-linecap='round' stroke-linejoin='round' stroke-width='2' d='m2 5 6 6 6-6'/%3e%3c/svg%3e\");display:block;width:100%;padding:.375rem 2.25rem .375rem .75rem;font-size:1rem;font-weight:400;line-height:1.5;color:var(--bs-body-color);background-color:var(--bs-body-bg);background-image:var(--bs-form-select-bg-img),var(--bs-form-select-bg-icon, none);background-repeat:no-repeat;background-position:right .75rem center;background-size:16px 12px;border:var(--bs-border-width) solid var(--bs-border-color);border-radius:var(--bs-border-radius);transition:border-color .15s ease-in-out,box-shadow .15s ease-in-out;-webkit-appearance:none;appearance:none}@media (prefers-reduced-motion: reduce){:host ::ng-deep .form-select{transition:none}}:host ::ng-deep .form-select:focus{border-color:#86b7fe;outline:0;box-shadow:0 0 0 .25rem #0d6efd40}:host ::ng-deep .form-select[multiple],:host ::ng-deep .form-select[size]:not([size=\"1\"]){padding-right:.75rem;background-image:none}:host ::ng-deep .form-select:disabled{background-color:var(--bs-secondary-bg)}:host ::ng-deep .form-select:-moz-focusring{color:transparent;text-shadow:0 0 0 var(--bs-body-color)}:host ::ng-deep .form-select-sm{padding-top:.25rem;padding-bottom:.25rem;padding-left:.5rem;font-size:.875rem;border-radius:var(--bs-border-radius-sm)}:host ::ng-deep .form-select-lg{padding-top:.5rem;padding-bottom:.5rem;padding-left:1rem;font-size:1.25rem;border-radius:var(--bs-border-radius-lg)}:host ::ng-deep [data-bs-theme=dark] .form-select{--bs-form-select-bg-img: url(\"data:image/svg+xml,%3csvg xmlns='http://www.w3.org/2000/svg' viewBox='0 0 16 16'%3e%3cpath fill='none' stroke='%23adb5bd' stroke-linecap='round' stroke-linejoin='round' stroke-width='2' d='m2 5 6 6 6-6'/%3e%3c/svg%3e\")}\n"] }]
        }], ctorParameters: function () { return [{ type: i0.Renderer2 }]; }, propDecorators: { identifier: [{
                type: Input
            }], selectBox: [{
                type: ViewChild,
                args: ['selectBox']
            }], size: [{
                type: Input
            }], multiple: [{
                type: Input
            }], numberVisible: [{
                type: Input
            }], disabled: [{
                type: Input
            }] } });

class BsSelectValueAccessor {
    constructor(_renderer, _elementRef, selectBox) {
        this._renderer = _renderer;
        this._elementRef = _elementRef;
        this.selectBox = selectBox;
        this.onChange = (_) => { };
        this.onTouched = () => { };
        this.optionMap = new Map();
        this.idCounter = 0;
        this.compareWithFunction = Object.is;
    }
    registerOnTouched(fn) {
        this.onTouched = fn;
    }
    registerOnChange(fn) {
        this.onChange = (valueString) => {
            // View -> Model
            this.value = this.getOptionValue(valueString);
            fn(this.value);
            // fn(valueString);
        };
    }
    setDisabledState(isDisabled) {
        this.setProperty('disabled', isDisabled);
    }
    setProperty(key, value) {
        // if (this._elementRef) {
        //   this._renderer.setProperty(this._elementRef.nativeElement, key, value);
        // }
        if (this.selectBox.selectBox) {
            this._renderer.setProperty(this.selectBox.selectBox.nativeElement, key, value);
        }
    }
    hostOnChange(ev) {
        this.onChange(ev.target.value);
    }
    hostBlur(ev) {
        this.onTouched();
    }
    set compareWith(value) {
        if (typeof value !== 'function') {
            throw new Error('compareWith must be a function');
        }
        this.compareWithFunction = value;
    }
    buildValueString(id, value) {
        if (id == null) {
            return `${value}`;
        }
        if (value && (typeof value === 'object')) {
            value = 'Object';
        }
        return `${id}: ${value}`.slice(0, 50);
    }
    extractId(valueString) {
        return valueString.split(':')[0];
    }
    writeValue(value) {
        this.value = value;
        // console.log(`WriteValue ${this.selectBox.identifier}`, value);
        const id = this.getOptionId(value);
        const valueString = this.buildValueString(id, value);
        this.setProperty('value', valueString);
    }
    registerOption() {
        return (this.idCounter++).toString();
    }
    getOptionId(value) {
        for (const id of Array.from(this.optionMap.keys())) {
            if (this.compareWithFunction(this.optionMap.get(id), value)) {
                return id;
            }
        }
        // This shouldn't happen
        // debugger;
        return null;
    }
    getOptionValue(valueString) {
        const id = this.extractId(valueString);
        return this.optionMap.has(id) ? this.optionMap.get(id) : valueString;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.0.4", ngImport: i0, type: BsSelectValueAccessor, deps: [{ token: i0.Renderer2 }, { token: i0.ElementRef }, { token: BsSelectComponent }], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "16.0.4", type: BsSelectValueAccessor, selector: "bs-select", inputs: { compareWith: "compareWith" }, host: { listeners: { "change": "hostOnChange($event)", "blur": "hostBlur($event)" } }, providers: [{
                provide: NG_VALUE_ACCESSOR,
                useExisting: forwardRef(() => BsSelectValueAccessor),
                multi: true,
            }], ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.0.4", ngImport: i0, type: BsSelectValueAccessor, decorators: [{
            type: Directive,
            args: [{
                    selector: 'bs-select',
                    providers: [{
                            provide: NG_VALUE_ACCESSOR,
                            useExisting: forwardRef(() => BsSelectValueAccessor),
                            multi: true,
                        }],
                }]
        }], ctorParameters: function () { return [{ type: i0.Renderer2 }, { type: i0.ElementRef }, { type: BsSelectComponent }]; }, propDecorators: { hostOnChange: [{
                type: HostListener,
                args: ['change', ['$event']]
            }], hostBlur: [{
                type: HostListener,
                args: ['blur', ['$event']]
            }], compareWith: [{
                type: Input
            }] } });
class BsSelectOption {
    constructor(element, renderer, select) {
        this.element = element;
        this.renderer = renderer;
        this.select = select;
        if (this.select) {
            this.id = this.select.registerOption();
        }
    }
    set ngValue(value) {
        if (this.select) {
            this.select.optionMap.set(this.id, value);
            this.setElementValue(this.select.buildValueString(this.id, value));
            // console.log('ngValue', this.select.value);
            this.select.writeValue(this.select.value);
        }
    }
    set value(value) {
        this.setElementValue(value);
        if (this.select) {
            this.select.writeValue(this.select.value);
        }
    }
    setElementValue(value) {
        // console.log('setElementValue', value);
        // const nativeSelect = this.select['selectBox'].selectBox;
        // if (nativeSelect) {
        //   this.renderer.setProperty(nativeSelect.nativeElement, 'value', value);
        // }
        this.renderer.setProperty(this.element.nativeElement, 'value', value);
    }
    ngOnDestroy() {
        if (this.select) {
            this.select.optionMap.delete(this.id);
            this.select.writeValue(this.select.value);
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.0.4", ngImport: i0, type: BsSelectOption, deps: [{ token: i0.ElementRef }, { token: i0.Renderer2 }, { token: BsSelectValueAccessor, host: true, optional: true }], target: i0.ɵɵFactoryTarget.Directive }); }
    static { this.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "16.0.4", type: BsSelectOption, selector: "option", inputs: { ngValue: "ngValue", value: "value" }, ngImport: i0 }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.0.4", ngImport: i0, type: BsSelectOption, decorators: [{
            type: Directive,
            args: [{ selector: 'option' }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }, { type: i0.Renderer2 }, { type: BsSelectValueAccessor, decorators: [{
                    type: Optional
                }, {
                    type: Host
                }] }]; }, propDecorators: { ngValue: [{
                type: Input,
                args: ['ngValue']
            }], value: [{
                type: Input,
                args: ['value']
            }] } });

class BsSelectModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.0.4", ngImport: i0, type: BsSelectModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.0.4", ngImport: i0, type: BsSelectModule, declarations: [BsSelectComponent,
            BsSelectValueAccessor,
            BsSelectOption], imports: [CommonModule], exports: [BsSelectComponent,
            BsSelectValueAccessor,
            BsSelectOption] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.0.4", ngImport: i0, type: BsSelectModule, imports: [CommonModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.0.4", ngImport: i0, type: BsSelectModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        BsSelectComponent,
                        BsSelectValueAccessor,
                        BsSelectOption
                    ],
                    imports: [CommonModule],
                    exports: [
                        BsSelectComponent,
                        BsSelectValueAccessor,
                        BsSelectOption
                    ],
                }]
        }] });

/**
 * Generated bundle index. Do not edit.
 */

export { BsSelectComponent, BsSelectModule, BsSelectOption, BsSelectValueAccessor };
//# sourceMappingURL=mintplayer-ng-bootstrap-select.mjs.map
