import * as i0 from '@angular/core';
import { Pipe, NgModule, InjectionToken } from '@angular/core';
import { CommonModule } from '@angular/common';

var Color;
(function (Color) {
    Color[Color["primary"] = 0] = "primary";
    Color[Color["secondary"] = 1] = "secondary";
    Color[Color["success"] = 2] = "success";
    Color[Color["danger"] = 3] = "danger";
    Color[Color["warning"] = 4] = "warning";
    Color[Color["info"] = 5] = "info";
    Color[Color["light"] = 6] = "light";
    Color[Color["dark"] = 7] = "dark";
    Color[Color["body"] = 8] = "body";
    Color[Color["white"] = 9] = "white";
    Color[Color["transparent"] = 10] = "transparent";
})(Color || (Color = {}));

class BsFontColorPipe {
    transform(color_hex) {
        if (color_hex === undefined || color_hex === null || color_hex.length < 7 || typeof (color_hex) !== 'string') {
            return '#FFFFFF';
        }
        const R_HEX = color_hex.substr(1, 2);
        const G_HEX = color_hex.substr(3, 2);
        const B_HEX = color_hex.substr(5, 2);
        const R_DEC = parseInt(R_HEX, 16);
        const G_DEC = parseInt(G_HEX, 16);
        const B_DEC = parseInt(B_HEX, 16);
        const CONTRAST_HEX = R_DEC * 0.299 + G_DEC * 0.587 + B_DEC * 0.114 > 186 ? '#000000' : '#FFFFFF';
        return CONTRAST_HEX;
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.0.4", ngImport: i0, type: BsFontColorPipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe }); }
    static { this.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "16.0.4", ngImport: i0, type: BsFontColorPipe, name: "bsFontColor" }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.0.4", ngImport: i0, type: BsFontColorPipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'bsFontColor'
                }]
        }] });

class BsFontColorPipeModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.0.4", ngImport: i0, type: BsFontColorPipeModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.0.4", ngImport: i0, type: BsFontColorPipeModule, declarations: [BsFontColorPipe], imports: [CommonModule], exports: [BsFontColorPipe] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.0.4", ngImport: i0, type: BsFontColorPipeModule, imports: [CommonModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.0.4", ngImport: i0, type: BsFontColorPipeModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        BsFontColorPipe
                    ],
                    imports: [
                        CommonModule
                    ],
                    exports: [
                        BsFontColorPipe
                    ]
                }]
        }] });

class UcFirstPipe {
    transform(value, ...args) {
        return value[0].toUpperCase() + value.slice(1);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.0.4", ngImport: i0, type: UcFirstPipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe }); }
    static { this.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "16.0.4", ngImport: i0, type: UcFirstPipe, name: "ucFirst" }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.0.4", ngImport: i0, type: UcFirstPipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'ucFirst'
                }]
        }] });

class BsUcFirstPipeModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.0.4", ngImport: i0, type: BsUcFirstPipeModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.0.4", ngImport: i0, type: BsUcFirstPipeModule, declarations: [UcFirstPipe], imports: [CommonModule], exports: [UcFirstPipe] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.0.4", ngImport: i0, type: BsUcFirstPipeModule, imports: [CommonModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.0.4", ngImport: i0, type: BsUcFirstPipeModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        UcFirstPipe
                    ],
                    imports: [
                        CommonModule
                    ],
                    exports: [
                        UcFirstPipe
                    ]
                }]
        }] });

class BsInListPipe {
    transform(items, parameter) {
        return items.some(item => item.id === parameter);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.0.4", ngImport: i0, type: BsInListPipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe }); }
    static { this.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "16.0.4", ngImport: i0, type: BsInListPipe, name: "inList" }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.0.4", ngImport: i0, type: BsInListPipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'inList'
                }]
        }] });

class BsInListModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.0.4", ngImport: i0, type: BsInListModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.0.4", ngImport: i0, type: BsInListModule, declarations: [BsInListPipe], imports: [CommonModule], exports: [BsInListPipe] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.0.4", ngImport: i0, type: BsInListModule, imports: [CommonModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.0.4", ngImport: i0, type: BsInListModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        BsInListPipe
                    ],
                    imports: [
                        CommonModule
                    ],
                    exports: [
                        BsInListPipe
                    ]
                }]
        }] });

/**
 * Register this provider with a **true** value to enable Development mode for ng-bootstrap.
 * This will make the overlays, which usually close when clicking outside of them,
 * to stay open.
 **/
const BS_DEVELOPMENT = new InjectionToken('BootstrapDevelopment');

/**
 * Generated bundle index. Do not edit.
 */

export { BS_DEVELOPMENT, BsFontColorPipe, BsFontColorPipeModule, BsInListModule, BsInListPipe, BsUcFirstPipeModule, Color, UcFirstPipe };
//# sourceMappingURL=mintplayer-ng-bootstrap.mjs.map
