import { ElementRef } from '@angular/core';
import { BehaviorSubject, Observable } from 'rxjs';
import { ResizeAction } from '../interfaces/resize-action';
import { ResizablePositioning } from '../types/positioning';
import { PresetPosition } from '../interfaces/preset-position';
import * as i0 from "@angular/core";
export declare class BsResizableComponent {
    constructor(element: ElementRef<HTMLElement>);
    resizeAction?: ResizeAction;
    element: ElementRef<HTMLElement>;
    hostPosition$: Observable<string>;
    wrapperPosition$: Observable<string[]>;
    positioning$: BehaviorSubject<ResizablePositioning>;
    get positioning(): ResizablePositioning;
    set positioning(value: ResizablePositioning);
    set presetPosition(value: PresetPosition);
    marginLeft?: number;
    marginRight?: number;
    marginTop?: number;
    marginBottom?: number;
    width?: number;
    height?: number;
    left?: number;
    top?: number;
    classes: boolean;
    hostClass: string | null;
    static ɵfac: i0.ɵɵFactoryDeclaration<BsResizableComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<BsResizableComponent, "bs-resizable", never, { "positioning": { "alias": "positioning"; "required": false; }; "presetPosition": { "alias": "presetPosition"; "required": false; }; }, {}, never, ["*"], false, never>;
}
