import * as i0 from '@angular/core';
import { Component, Input, NgModule } from '@angular/core';
import { BehaviorSubject } from 'rxjs';
import * as i1 from '@angular/common';
import { CommonModule } from '@angular/common';

class BsTableComponent {
    constructor() {
        //#region isResponsive
        this.isResponsive$ = new BehaviorSubject(false);
        //#endregion
        //#region striped
        this.striped$ = new BehaviorSubject(false);
        //#endregion
        //#region hover
        this.hover$ = new BehaviorSubject(false);
    }
    get isResponsive() {
        return this.isResponsive$.value;
    }
    set isResponsive(value) {
        this.isResponsive$.next(value);
    }
    get striped() {
        return this.striped$.value;
    }
    set striped(value) {
        this.striped$.next(value);
    }
    get hover() {
        return this.hover$.value;
    }
    set hover(value) {
        this.hover$.next(value);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.0.4", ngImport: i0, type: BsTableComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "16.0.4", type: BsTableComponent, selector: "bs-table", inputs: { isResponsive: "isResponsive", striped: "striped", hover: "hover" }, ngImport: i0, template: "<div class=\"d-block\" [class.table-responsive]=\"isResponsive$ | async\" [class.nowrap]=\"isResponsive$ | async\">\n    <table class=\"table\" cellspacing=\"0\" role=\"grid\"\n        [class.mb-0]=\"isResponsive$ | async\"\n        [class.table-striped]=\"striped$ | async\"\n        [class.table-hover]=\"hover$ | async\">\n\n        <ng-content></ng-content>\n\n    </table>\n</div>\n", styles: [":host ::ng-deep *,:host ::ng-deep *:before,:host ::ng-deep *:after{box-sizing:border-box}@media (prefers-reduced-motion: no-preference){:host ::ng-deep :root{scroll-behavior:smooth}}:host ::ng-deep body{margin:0;font-family:var(--bs-body-font-family);font-size:var(--bs-body-font-size);font-weight:var(--bs-body-font-weight);line-height:var(--bs-body-line-height);color:var(--bs-body-color);text-align:var(--bs-body-text-align);background-color:var(--bs-body-bg);-webkit-text-size-adjust:100%;-webkit-tap-highlight-color:rgba(0,0,0,0)}:host ::ng-deep hr{margin:1rem 0;color:inherit;border:0;border-top:var(--bs-border-width) solid;opacity:.25}:host ::ng-deep h6,:host ::ng-deep h5,:host ::ng-deep h4,:host ::ng-deep h3,:host ::ng-deep h2,:host ::ng-deep h1{margin-top:0;margin-bottom:.5rem;font-weight:500;line-height:1.2;color:var(--bs-heading-color)}:host ::ng-deep h1{font-size:calc(1.375rem + 1.5vw)}@media (min-width: 1200px){:host ::ng-deep h1{font-size:2.5rem}}:host ::ng-deep h2{font-size:calc(1.325rem + .9vw)}@media (min-width: 1200px){:host ::ng-deep h2{font-size:2rem}}:host ::ng-deep h3{font-size:calc(1.3rem + .6vw)}@media (min-width: 1200px){:host ::ng-deep h3{font-size:1.75rem}}:host ::ng-deep h4{font-size:calc(1.275rem + .3vw)}@media (min-width: 1200px){:host ::ng-deep h4{font-size:1.5rem}}:host ::ng-deep h5{font-size:1.25rem}:host ::ng-deep h6{font-size:1rem}:host ::ng-deep p{margin-top:0;margin-bottom:1rem}:host ::ng-deep abbr[title]{-webkit-text-decoration:underline dotted;text-decoration:underline dotted;cursor:help;-webkit-text-decoration-skip-ink:none;text-decoration-skip-ink:none}:host ::ng-deep address{margin-bottom:1rem;font-style:normal;line-height:inherit}:host ::ng-deep ol,:host ::ng-deep ul{padding-left:2rem}:host ::ng-deep ol,:host ::ng-deep ul,:host ::ng-deep dl{margin-top:0;margin-bottom:1rem}:host ::ng-deep ol ol,:host ::ng-deep ul ul,:host ::ng-deep ol ul,:host ::ng-deep ul ol{margin-bottom:0}:host ::ng-deep dt{font-weight:700}:host ::ng-deep dd{margin-bottom:.5rem;margin-left:0}:host ::ng-deep blockquote{margin:0 0 1rem}:host ::ng-deep b,:host ::ng-deep strong{font-weight:bolder}:host ::ng-deep small{font-size:.875em}:host ::ng-deep mark{padding:.1875em;background-color:var(--bs-highlight-bg)}:host ::ng-deep sub,:host ::ng-deep sup{position:relative;font-size:.75em;line-height:0;vertical-align:baseline}:host ::ng-deep sub{bottom:-.25em}:host ::ng-deep sup{top:-.5em}:host ::ng-deep a{color:rgba(var(--bs-link-color-rgb),var(--bs-link-opacity, 1));text-decoration:underline}:host ::ng-deep a:hover{--bs-link-color-rgb: var(--bs-link-hover-color-rgb)}:host ::ng-deep a:not([href]):not([class]),:host ::ng-deep a:not([href]):not([class]):hover{color:inherit;text-decoration:none}:host ::ng-deep pre,:host ::ng-deep code,:host ::ng-deep kbd,:host ::ng-deep samp{font-family:var(--bs-font-monospace);font-size:1em}:host ::ng-deep pre{display:block;margin-top:0;margin-bottom:1rem;overflow:auto;font-size:.875em}:host ::ng-deep pre code{font-size:inherit;color:inherit;word-break:normal}:host ::ng-deep code{font-size:.875em;color:var(--bs-code-color);word-wrap:break-word}a>:host ::ng-deep code{color:inherit}:host ::ng-deep kbd{padding:.1875rem .375rem;font-size:.875em;color:var(--bs-body-bg);background-color:var(--bs-body-color);border-radius:.25rem}:host ::ng-deep kbd kbd{padding:0;font-size:1em}:host ::ng-deep figure{margin:0 0 1rem}:host ::ng-deep img,:host ::ng-deep svg{vertical-align:middle}:host ::ng-deep table{caption-side:bottom;border-collapse:collapse}:host ::ng-deep caption{padding-top:.5rem;padding-bottom:.5rem;color:var(--bs-secondary-color);text-align:left}:host ::ng-deep th{text-align:inherit;text-align:-webkit-match-parent}:host ::ng-deep thead,:host ::ng-deep tbody,:host ::ng-deep tfoot,:host ::ng-deep tr,:host ::ng-deep td,:host ::ng-deep th{border-color:inherit;border-style:solid;border-width:0}:host ::ng-deep label{display:inline-block}:host ::ng-deep button{border-radius:0}:host ::ng-deep button:focus:not(:focus-visible){outline:0}:host ::ng-deep input,:host ::ng-deep button,:host ::ng-deep select,:host ::ng-deep optgroup,:host ::ng-deep textarea{margin:0;font-family:inherit;font-size:inherit;line-height:inherit}:host ::ng-deep button,:host ::ng-deep select{text-transform:none}:host ::ng-deep [role=button]{cursor:pointer}:host ::ng-deep select{word-wrap:normal}:host ::ng-deep select:disabled{opacity:1}:host ::ng-deep [list]:not([type=date]):not([type=datetime-local]):not([type=month]):not([type=week]):not([type=time])::-webkit-calendar-picker-indicator{display:none!important}:host ::ng-deep button,:host ::ng-deep [type=button],:host ::ng-deep [type=reset],:host ::ng-deep [type=submit]{-webkit-appearance:button}:host ::ng-deep button:not(:disabled),:host ::ng-deep [type=button]:not(:disabled),:host ::ng-deep [type=reset]:not(:disabled),:host ::ng-deep [type=submit]:not(:disabled){cursor:pointer}:host ::ng-deep ::-moz-focus-inner{padding:0;border-style:none}:host ::ng-deep textarea{resize:vertical}:host ::ng-deep fieldset{min-width:0;padding:0;margin:0;border:0}:host ::ng-deep legend{float:left;width:100%;padding:0;margin-bottom:.5rem;font-size:calc(1.275rem + .3vw);line-height:inherit}@media (min-width: 1200px){:host ::ng-deep legend{font-size:1.5rem}}:host ::ng-deep legend+*{clear:left}:host ::ng-deep ::-webkit-datetime-edit-fields-wrapper,:host ::ng-deep ::-webkit-datetime-edit-text,:host ::ng-deep ::-webkit-datetime-edit-minute,:host ::ng-deep ::-webkit-datetime-edit-hour-field,:host ::ng-deep ::-webkit-datetime-edit-day-field,:host ::ng-deep ::-webkit-datetime-edit-month-field,:host ::ng-deep ::-webkit-datetime-edit-year-field{padding:0}:host ::ng-deep ::-webkit-inner-spin-button{height:auto}:host ::ng-deep [type=search]{outline-offset:-2px;-webkit-appearance:textfield}:host ::ng-deep ::-webkit-search-decoration{-webkit-appearance:none}:host ::ng-deep ::-webkit-color-swatch-wrapper{padding:0}:host ::ng-deep ::file-selector-button{font:inherit;-webkit-appearance:button}:host ::ng-deep output{display:inline-block}:host ::ng-deep iframe{border:0}:host ::ng-deep summary{display:list-item;cursor:pointer}:host ::ng-deep progress{vertical-align:baseline}:host ::ng-deep [hidden]{display:none!important}:host ::ng-deep .table{--bs-table-color-type: initial;--bs-table-bg-type: initial;--bs-table-color-state: initial;--bs-table-bg-state: initial;--bs-table-color: var(--bs-body-color);--bs-table-bg: var(--bs-body-bg);--bs-table-border-color: var(--bs-border-color);--bs-table-accent-bg: transparent;--bs-table-striped-color: var(--bs-body-color);--bs-table-striped-bg: rgba(0, 0, 0, .05);--bs-table-active-color: var(--bs-body-color);--bs-table-active-bg: rgba(0, 0, 0, .1);--bs-table-hover-color: var(--bs-body-color);--bs-table-hover-bg: rgba(0, 0, 0, .075);width:100%;margin-bottom:1rem;vertical-align:top;border-color:var(--bs-table-border-color)}:host ::ng-deep .table>:not(caption)>*>*{padding:.5rem;color:var(--bs-table-color-state, var(--bs-table-color-type, var(--bs-table-color)));background-color:var(--bs-table-bg);border-bottom-width:var(--bs-border-width);box-shadow:inset 0 0 0 9999px var(--bs-table-bg-state, var(--bs-table-bg-type, var(--bs-table-accent-bg)))}:host ::ng-deep .table>tbody{vertical-align:inherit}:host ::ng-deep .table>thead{vertical-align:bottom}:host ::ng-deep .table-group-divider{border-top:calc(var(--bs-border-width) * 2) solid currentcolor}:host ::ng-deep .caption-top{caption-side:top}:host ::ng-deep .table-sm>:not(caption)>*>*{padding:.25rem}:host ::ng-deep .table-bordered>:not(caption)>*{border-width:var(--bs-border-width) 0}:host ::ng-deep .table-bordered>:not(caption)>*>*{border-width:0 var(--bs-border-width)}:host ::ng-deep .table-borderless>:not(caption)>*>*{border-bottom-width:0}:host ::ng-deep .table-borderless>:not(:first-child){border-top-width:0}:host ::ng-deep .table-striped>tbody>tr:nth-of-type(odd)>*{--bs-table-color-type: var(--bs-table-striped-color);--bs-table-bg-type: var(--bs-table-striped-bg)}:host ::ng-deep .table-striped-columns>:not(caption)>tr>:nth-child(even){--bs-table-color-type: var(--bs-table-striped-color);--bs-table-bg-type: var(--bs-table-striped-bg)}:host ::ng-deep .table-active{--bs-table-color-state: var(--bs-table-active-color);--bs-table-bg-state: var(--bs-table-active-bg)}:host ::ng-deep .table-hover>tbody>tr:hover>*{--bs-table-color-state: var(--bs-table-hover-color);--bs-table-bg-state: var(--bs-table-hover-bg)}:host ::ng-deep .table-primary{--bs-table-color: #000;--bs-table-bg: #cfe2ff;--bs-table-border-color: #bacbe6;--bs-table-striped-bg: #c5d7f2;--bs-table-striped-color: #000;--bs-table-active-bg: #bacbe6;--bs-table-active-color: #000;--bs-table-hover-bg: #bfd1ec;--bs-table-hover-color: #000;color:var(--bs-table-color);border-color:var(--bs-table-border-color)}:host ::ng-deep .table-secondary{--bs-table-color: #000;--bs-table-bg: #e2e3e5;--bs-table-border-color: #cbccce;--bs-table-striped-bg: #d7d8da;--bs-table-striped-color: #000;--bs-table-active-bg: #cbccce;--bs-table-active-color: #000;--bs-table-hover-bg: #d1d2d4;--bs-table-hover-color: #000;color:var(--bs-table-color);border-color:var(--bs-table-border-color)}:host ::ng-deep .table-success{--bs-table-color: #000;--bs-table-bg: #d1e7dd;--bs-table-border-color: #bcd0c7;--bs-table-striped-bg: #c7dbd2;--bs-table-striped-color: #000;--bs-table-active-bg: #bcd0c7;--bs-table-active-color: #000;--bs-table-hover-bg: #c1d6cc;--bs-table-hover-color: #000;color:var(--bs-table-color);border-color:var(--bs-table-border-color)}:host ::ng-deep .table-info{--bs-table-color: #000;--bs-table-bg: #cff4fc;--bs-table-border-color: #badce3;--bs-table-striped-bg: #c5e8ef;--bs-table-striped-color: #000;--bs-table-active-bg: #badce3;--bs-table-active-color: #000;--bs-table-hover-bg: #bfe2e9;--bs-table-hover-color: #000;color:var(--bs-table-color);border-color:var(--bs-table-border-color)}:host ::ng-deep .table-warning{--bs-table-color: #000;--bs-table-bg: #fff3cd;--bs-table-border-color: #e6dbb9;--bs-table-striped-bg: #f2e7c3;--bs-table-striped-color: #000;--bs-table-active-bg: #e6dbb9;--bs-table-active-color: #000;--bs-table-hover-bg: #ece1be;--bs-table-hover-color: #000;color:var(--bs-table-color);border-color:var(--bs-table-border-color)}:host ::ng-deep .table-danger{--bs-table-color: #000;--bs-table-bg: #f8d7da;--bs-table-border-color: #dfc2c4;--bs-table-striped-bg: #eccccf;--bs-table-striped-color: #000;--bs-table-active-bg: #dfc2c4;--bs-table-active-color: #000;--bs-table-hover-bg: #e5c7ca;--bs-table-hover-color: #000;color:var(--bs-table-color);border-color:var(--bs-table-border-color)}:host ::ng-deep .table-light{--bs-table-color: #000;--bs-table-bg: #f8f9fa;--bs-table-border-color: #dfe0e1;--bs-table-striped-bg: #ecedee;--bs-table-striped-color: #000;--bs-table-active-bg: #dfe0e1;--bs-table-active-color: #000;--bs-table-hover-bg: #e5e6e7;--bs-table-hover-color: #000;color:var(--bs-table-color);border-color:var(--bs-table-border-color)}:host ::ng-deep .table-dark{--bs-table-color: #fff;--bs-table-bg: #212529;--bs-table-border-color: #373b3e;--bs-table-striped-bg: #2c3034;--bs-table-striped-color: #fff;--bs-table-active-bg: #373b3e;--bs-table-active-color: #fff;--bs-table-hover-bg: #323539;--bs-table-hover-color: #fff;color:var(--bs-table-color);border-color:var(--bs-table-border-color)}:host ::ng-deep .table-responsive{overflow-x:auto;-webkit-overflow-scrolling:touch}@media (max-width: 575.98px){:host ::ng-deep .table-responsive-sm{overflow-x:auto;-webkit-overflow-scrolling:touch}}@media (max-width: 767.98px){:host ::ng-deep .table-responsive-md{overflow-x:auto;-webkit-overflow-scrolling:touch}}@media (max-width: 991.98px){:host ::ng-deep .table-responsive-lg{overflow-x:auto;-webkit-overflow-scrolling:touch}}@media (max-width: 1199.98px){:host ::ng-deep .table-responsive-xl{overflow-x:auto;-webkit-overflow-scrolling:touch}}@media (max-width: 1399.98px){:host ::ng-deep .table-responsive-xxl{overflow-x:auto;-webkit-overflow-scrolling:touch}}:host ::ng-deep .nowrap th,:host ::ng-deep td{white-space:nowrap}\n"], dependencies: [{ kind: "pipe", type: i1.AsyncPipe, name: "async" }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.0.4", ngImport: i0, type: BsTableComponent, decorators: [{
            type: Component,
            args: [{ selector: 'bs-table', template: "<div class=\"d-block\" [class.table-responsive]=\"isResponsive$ | async\" [class.nowrap]=\"isResponsive$ | async\">\n    <table class=\"table\" cellspacing=\"0\" role=\"grid\"\n        [class.mb-0]=\"isResponsive$ | async\"\n        [class.table-striped]=\"striped$ | async\"\n        [class.table-hover]=\"hover$ | async\">\n\n        <ng-content></ng-content>\n\n    </table>\n</div>\n", styles: [":host ::ng-deep *,:host ::ng-deep *:before,:host ::ng-deep *:after{box-sizing:border-box}@media (prefers-reduced-motion: no-preference){:host ::ng-deep :root{scroll-behavior:smooth}}:host ::ng-deep body{margin:0;font-family:var(--bs-body-font-family);font-size:var(--bs-body-font-size);font-weight:var(--bs-body-font-weight);line-height:var(--bs-body-line-height);color:var(--bs-body-color);text-align:var(--bs-body-text-align);background-color:var(--bs-body-bg);-webkit-text-size-adjust:100%;-webkit-tap-highlight-color:rgba(0,0,0,0)}:host ::ng-deep hr{margin:1rem 0;color:inherit;border:0;border-top:var(--bs-border-width) solid;opacity:.25}:host ::ng-deep h6,:host ::ng-deep h5,:host ::ng-deep h4,:host ::ng-deep h3,:host ::ng-deep h2,:host ::ng-deep h1{margin-top:0;margin-bottom:.5rem;font-weight:500;line-height:1.2;color:var(--bs-heading-color)}:host ::ng-deep h1{font-size:calc(1.375rem + 1.5vw)}@media (min-width: 1200px){:host ::ng-deep h1{font-size:2.5rem}}:host ::ng-deep h2{font-size:calc(1.325rem + .9vw)}@media (min-width: 1200px){:host ::ng-deep h2{font-size:2rem}}:host ::ng-deep h3{font-size:calc(1.3rem + .6vw)}@media (min-width: 1200px){:host ::ng-deep h3{font-size:1.75rem}}:host ::ng-deep h4{font-size:calc(1.275rem + .3vw)}@media (min-width: 1200px){:host ::ng-deep h4{font-size:1.5rem}}:host ::ng-deep h5{font-size:1.25rem}:host ::ng-deep h6{font-size:1rem}:host ::ng-deep p{margin-top:0;margin-bottom:1rem}:host ::ng-deep abbr[title]{-webkit-text-decoration:underline dotted;text-decoration:underline dotted;cursor:help;-webkit-text-decoration-skip-ink:none;text-decoration-skip-ink:none}:host ::ng-deep address{margin-bottom:1rem;font-style:normal;line-height:inherit}:host ::ng-deep ol,:host ::ng-deep ul{padding-left:2rem}:host ::ng-deep ol,:host ::ng-deep ul,:host ::ng-deep dl{margin-top:0;margin-bottom:1rem}:host ::ng-deep ol ol,:host ::ng-deep ul ul,:host ::ng-deep ol ul,:host ::ng-deep ul ol{margin-bottom:0}:host ::ng-deep dt{font-weight:700}:host ::ng-deep dd{margin-bottom:.5rem;margin-left:0}:host ::ng-deep blockquote{margin:0 0 1rem}:host ::ng-deep b,:host ::ng-deep strong{font-weight:bolder}:host ::ng-deep small{font-size:.875em}:host ::ng-deep mark{padding:.1875em;background-color:var(--bs-highlight-bg)}:host ::ng-deep sub,:host ::ng-deep sup{position:relative;font-size:.75em;line-height:0;vertical-align:baseline}:host ::ng-deep sub{bottom:-.25em}:host ::ng-deep sup{top:-.5em}:host ::ng-deep a{color:rgba(var(--bs-link-color-rgb),var(--bs-link-opacity, 1));text-decoration:underline}:host ::ng-deep a:hover{--bs-link-color-rgb: var(--bs-link-hover-color-rgb)}:host ::ng-deep a:not([href]):not([class]),:host ::ng-deep a:not([href]):not([class]):hover{color:inherit;text-decoration:none}:host ::ng-deep pre,:host ::ng-deep code,:host ::ng-deep kbd,:host ::ng-deep samp{font-family:var(--bs-font-monospace);font-size:1em}:host ::ng-deep pre{display:block;margin-top:0;margin-bottom:1rem;overflow:auto;font-size:.875em}:host ::ng-deep pre code{font-size:inherit;color:inherit;word-break:normal}:host ::ng-deep code{font-size:.875em;color:var(--bs-code-color);word-wrap:break-word}a>:host ::ng-deep code{color:inherit}:host ::ng-deep kbd{padding:.1875rem .375rem;font-size:.875em;color:var(--bs-body-bg);background-color:var(--bs-body-color);border-radius:.25rem}:host ::ng-deep kbd kbd{padding:0;font-size:1em}:host ::ng-deep figure{margin:0 0 1rem}:host ::ng-deep img,:host ::ng-deep svg{vertical-align:middle}:host ::ng-deep table{caption-side:bottom;border-collapse:collapse}:host ::ng-deep caption{padding-top:.5rem;padding-bottom:.5rem;color:var(--bs-secondary-color);text-align:left}:host ::ng-deep th{text-align:inherit;text-align:-webkit-match-parent}:host ::ng-deep thead,:host ::ng-deep tbody,:host ::ng-deep tfoot,:host ::ng-deep tr,:host ::ng-deep td,:host ::ng-deep th{border-color:inherit;border-style:solid;border-width:0}:host ::ng-deep label{display:inline-block}:host ::ng-deep button{border-radius:0}:host ::ng-deep button:focus:not(:focus-visible){outline:0}:host ::ng-deep input,:host ::ng-deep button,:host ::ng-deep select,:host ::ng-deep optgroup,:host ::ng-deep textarea{margin:0;font-family:inherit;font-size:inherit;line-height:inherit}:host ::ng-deep button,:host ::ng-deep select{text-transform:none}:host ::ng-deep [role=button]{cursor:pointer}:host ::ng-deep select{word-wrap:normal}:host ::ng-deep select:disabled{opacity:1}:host ::ng-deep [list]:not([type=date]):not([type=datetime-local]):not([type=month]):not([type=week]):not([type=time])::-webkit-calendar-picker-indicator{display:none!important}:host ::ng-deep button,:host ::ng-deep [type=button],:host ::ng-deep [type=reset],:host ::ng-deep [type=submit]{-webkit-appearance:button}:host ::ng-deep button:not(:disabled),:host ::ng-deep [type=button]:not(:disabled),:host ::ng-deep [type=reset]:not(:disabled),:host ::ng-deep [type=submit]:not(:disabled){cursor:pointer}:host ::ng-deep ::-moz-focus-inner{padding:0;border-style:none}:host ::ng-deep textarea{resize:vertical}:host ::ng-deep fieldset{min-width:0;padding:0;margin:0;border:0}:host ::ng-deep legend{float:left;width:100%;padding:0;margin-bottom:.5rem;font-size:calc(1.275rem + .3vw);line-height:inherit}@media (min-width: 1200px){:host ::ng-deep legend{font-size:1.5rem}}:host ::ng-deep legend+*{clear:left}:host ::ng-deep ::-webkit-datetime-edit-fields-wrapper,:host ::ng-deep ::-webkit-datetime-edit-text,:host ::ng-deep ::-webkit-datetime-edit-minute,:host ::ng-deep ::-webkit-datetime-edit-hour-field,:host ::ng-deep ::-webkit-datetime-edit-day-field,:host ::ng-deep ::-webkit-datetime-edit-month-field,:host ::ng-deep ::-webkit-datetime-edit-year-field{padding:0}:host ::ng-deep ::-webkit-inner-spin-button{height:auto}:host ::ng-deep [type=search]{outline-offset:-2px;-webkit-appearance:textfield}:host ::ng-deep ::-webkit-search-decoration{-webkit-appearance:none}:host ::ng-deep ::-webkit-color-swatch-wrapper{padding:0}:host ::ng-deep ::file-selector-button{font:inherit;-webkit-appearance:button}:host ::ng-deep output{display:inline-block}:host ::ng-deep iframe{border:0}:host ::ng-deep summary{display:list-item;cursor:pointer}:host ::ng-deep progress{vertical-align:baseline}:host ::ng-deep [hidden]{display:none!important}:host ::ng-deep .table{--bs-table-color-type: initial;--bs-table-bg-type: initial;--bs-table-color-state: initial;--bs-table-bg-state: initial;--bs-table-color: var(--bs-body-color);--bs-table-bg: var(--bs-body-bg);--bs-table-border-color: var(--bs-border-color);--bs-table-accent-bg: transparent;--bs-table-striped-color: var(--bs-body-color);--bs-table-striped-bg: rgba(0, 0, 0, .05);--bs-table-active-color: var(--bs-body-color);--bs-table-active-bg: rgba(0, 0, 0, .1);--bs-table-hover-color: var(--bs-body-color);--bs-table-hover-bg: rgba(0, 0, 0, .075);width:100%;margin-bottom:1rem;vertical-align:top;border-color:var(--bs-table-border-color)}:host ::ng-deep .table>:not(caption)>*>*{padding:.5rem;color:var(--bs-table-color-state, var(--bs-table-color-type, var(--bs-table-color)));background-color:var(--bs-table-bg);border-bottom-width:var(--bs-border-width);box-shadow:inset 0 0 0 9999px var(--bs-table-bg-state, var(--bs-table-bg-type, var(--bs-table-accent-bg)))}:host ::ng-deep .table>tbody{vertical-align:inherit}:host ::ng-deep .table>thead{vertical-align:bottom}:host ::ng-deep .table-group-divider{border-top:calc(var(--bs-border-width) * 2) solid currentcolor}:host ::ng-deep .caption-top{caption-side:top}:host ::ng-deep .table-sm>:not(caption)>*>*{padding:.25rem}:host ::ng-deep .table-bordered>:not(caption)>*{border-width:var(--bs-border-width) 0}:host ::ng-deep .table-bordered>:not(caption)>*>*{border-width:0 var(--bs-border-width)}:host ::ng-deep .table-borderless>:not(caption)>*>*{border-bottom-width:0}:host ::ng-deep .table-borderless>:not(:first-child){border-top-width:0}:host ::ng-deep .table-striped>tbody>tr:nth-of-type(odd)>*{--bs-table-color-type: var(--bs-table-striped-color);--bs-table-bg-type: var(--bs-table-striped-bg)}:host ::ng-deep .table-striped-columns>:not(caption)>tr>:nth-child(even){--bs-table-color-type: var(--bs-table-striped-color);--bs-table-bg-type: var(--bs-table-striped-bg)}:host ::ng-deep .table-active{--bs-table-color-state: var(--bs-table-active-color);--bs-table-bg-state: var(--bs-table-active-bg)}:host ::ng-deep .table-hover>tbody>tr:hover>*{--bs-table-color-state: var(--bs-table-hover-color);--bs-table-bg-state: var(--bs-table-hover-bg)}:host ::ng-deep .table-primary{--bs-table-color: #000;--bs-table-bg: #cfe2ff;--bs-table-border-color: #bacbe6;--bs-table-striped-bg: #c5d7f2;--bs-table-striped-color: #000;--bs-table-active-bg: #bacbe6;--bs-table-active-color: #000;--bs-table-hover-bg: #bfd1ec;--bs-table-hover-color: #000;color:var(--bs-table-color);border-color:var(--bs-table-border-color)}:host ::ng-deep .table-secondary{--bs-table-color: #000;--bs-table-bg: #e2e3e5;--bs-table-border-color: #cbccce;--bs-table-striped-bg: #d7d8da;--bs-table-striped-color: #000;--bs-table-active-bg: #cbccce;--bs-table-active-color: #000;--bs-table-hover-bg: #d1d2d4;--bs-table-hover-color: #000;color:var(--bs-table-color);border-color:var(--bs-table-border-color)}:host ::ng-deep .table-success{--bs-table-color: #000;--bs-table-bg: #d1e7dd;--bs-table-border-color: #bcd0c7;--bs-table-striped-bg: #c7dbd2;--bs-table-striped-color: #000;--bs-table-active-bg: #bcd0c7;--bs-table-active-color: #000;--bs-table-hover-bg: #c1d6cc;--bs-table-hover-color: #000;color:var(--bs-table-color);border-color:var(--bs-table-border-color)}:host ::ng-deep .table-info{--bs-table-color: #000;--bs-table-bg: #cff4fc;--bs-table-border-color: #badce3;--bs-table-striped-bg: #c5e8ef;--bs-table-striped-color: #000;--bs-table-active-bg: #badce3;--bs-table-active-color: #000;--bs-table-hover-bg: #bfe2e9;--bs-table-hover-color: #000;color:var(--bs-table-color);border-color:var(--bs-table-border-color)}:host ::ng-deep .table-warning{--bs-table-color: #000;--bs-table-bg: #fff3cd;--bs-table-border-color: #e6dbb9;--bs-table-striped-bg: #f2e7c3;--bs-table-striped-color: #000;--bs-table-active-bg: #e6dbb9;--bs-table-active-color: #000;--bs-table-hover-bg: #ece1be;--bs-table-hover-color: #000;color:var(--bs-table-color);border-color:var(--bs-table-border-color)}:host ::ng-deep .table-danger{--bs-table-color: #000;--bs-table-bg: #f8d7da;--bs-table-border-color: #dfc2c4;--bs-table-striped-bg: #eccccf;--bs-table-striped-color: #000;--bs-table-active-bg: #dfc2c4;--bs-table-active-color: #000;--bs-table-hover-bg: #e5c7ca;--bs-table-hover-color: #000;color:var(--bs-table-color);border-color:var(--bs-table-border-color)}:host ::ng-deep .table-light{--bs-table-color: #000;--bs-table-bg: #f8f9fa;--bs-table-border-color: #dfe0e1;--bs-table-striped-bg: #ecedee;--bs-table-striped-color: #000;--bs-table-active-bg: #dfe0e1;--bs-table-active-color: #000;--bs-table-hover-bg: #e5e6e7;--bs-table-hover-color: #000;color:var(--bs-table-color);border-color:var(--bs-table-border-color)}:host ::ng-deep .table-dark{--bs-table-color: #fff;--bs-table-bg: #212529;--bs-table-border-color: #373b3e;--bs-table-striped-bg: #2c3034;--bs-table-striped-color: #fff;--bs-table-active-bg: #373b3e;--bs-table-active-color: #fff;--bs-table-hover-bg: #323539;--bs-table-hover-color: #fff;color:var(--bs-table-color);border-color:var(--bs-table-border-color)}:host ::ng-deep .table-responsive{overflow-x:auto;-webkit-overflow-scrolling:touch}@media (max-width: 575.98px){:host ::ng-deep .table-responsive-sm{overflow-x:auto;-webkit-overflow-scrolling:touch}}@media (max-width: 767.98px){:host ::ng-deep .table-responsive-md{overflow-x:auto;-webkit-overflow-scrolling:touch}}@media (max-width: 991.98px){:host ::ng-deep .table-responsive-lg{overflow-x:auto;-webkit-overflow-scrolling:touch}}@media (max-width: 1199.98px){:host ::ng-deep .table-responsive-xl{overflow-x:auto;-webkit-overflow-scrolling:touch}}@media (max-width: 1399.98px){:host ::ng-deep .table-responsive-xxl{overflow-x:auto;-webkit-overflow-scrolling:touch}}:host ::ng-deep .nowrap th,:host ::ng-deep td{white-space:nowrap}\n"] }]
        }], propDecorators: { isResponsive: [{
                type: Input
            }], striped: [{
                type: Input
            }], hover: [{
                type: Input
            }] } });

class BsTableModule {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "16.0.4", ngImport: i0, type: BsTableModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule }); }
    static { this.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "16.0.4", ngImport: i0, type: BsTableModule, declarations: [BsTableComponent], imports: [CommonModule], exports: [BsTableComponent] }); }
    static { this.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "16.0.4", ngImport: i0, type: BsTableModule, imports: [CommonModule] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "16.0.4", ngImport: i0, type: BsTableModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [BsTableComponent],
                    imports: [CommonModule],
                    exports: [BsTableComponent],
                }]
        }] });

/**
 * Generated bundle index. Do not edit.
 */

export { BsTableComponent, BsTableModule };
//# sourceMappingURL=mintplayer-ng-bootstrap-table.mjs.map
